/*
 * LecType1.java
 *
 * Created on March 9, 2003, 5:31 PM
 */

/**
 *
 * @author  Ravi
 */

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import graphs.*;


public class LecType1 extends javax.swing.JApplet {
    private GraphPanel currentGraph;
    
    /** Creates new form LecType1 */
    public LecType1() {
        initComponents();
        this.getContentPane().setBackground(this.getBackground());
    }
    
    public void init(){
        eqNum = -1;
        try {
            eqNum = Integer.parseInt(getParameter("eqNum"));
        } catch(Exception e){
            e.printStackTrace();
        }
        
        String functionName = "";
        String xAxisImgName = "";
        String yAxisImgName = "";
        String[] sliderImageNames = null;
        
        switch(eqNum){
            case 0:
                currentGraph = new TDSourcePGraph();
                functionName = "images/Eqn101.JPG";
                xAxisImgName = "images/r.JPG";
                yAxisImgName = "images/phi.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/mparam.JPG";
                break;
            case 1:
                currentGraph = new CosGraph();
//                functionName = "images/vote.gif";
                break;
           /* case 2:
                currentGraph = new CosGraph2();
                functionName = "images/vote.gif";
                break;*/
            case 3:
                currentGraph = new TDSourceVGraph();
                functionName = "images/Eqn102.JPG";
                xAxisImgName = "images/r.JPG";
                yAxisImgName = "images/vr.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/mparam.JPG";
                
                break;
            case 4:
                currentGraph = new TDSourceCGraph();
                functionName = "images/Eqn103.JPG";
                xAxisImgName = "images/theta.JPG";
                yAxisImgName = "images/chi.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/mparam.JPG";
                break;
                
            case 5:
                currentGraph = new TDVortexPGraph();
                functionName = "images/Eqn104.JPG";
                xAxisImgName = "images/theta.JPG";
                yAxisImgName = "images/phi.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/gamma.JPG";
                
                break;
            case 6:
                currentGraph = new TDVortexVGraph();
                functionName = "images/Eqn105.JPG";
                xAxisImgName = "images/r.JPG";
                yAxisImgName = "images/vtheta.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/gamma.JPG";
                break;
            case 7:
                currentGraph = new TDVortexCGraph();
                functionName = "images/Eqn106.JPG";
                xAxisImgName = "images/r.JPG";
                yAxisImgName = "images/chi.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/gamma.JPG";
                break;
            case 8:
                currentGraph = new StagPtXGraph();
                functionName = "images/Eqn107.JPG";
                yAxisImgName = "images/xs.JPG";
                xAxisImgName = "images/m.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/uparam.JPG";
                break;
                
            case 9:
                currentGraph = new RHBodyWGraph();
                functionName = "images/Eqn108.JPG";
                yAxisImgName = "images/D.JPG";
                xAxisImgName = "images/m.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/uparam.JPG";
                break;
                
            case 10:
                currentGraph = new ROvoidGraph();
                functionName = "images/Eqn109.JPG";
                xAxisImgName = "images/a.JPG";
                yAxisImgName = "images/xs.JPG";
                sliderImageNames = new String[2];
                sliderImageNames[0] = "images/uparam.JPG";
                sliderImageNames[1] = "images/mparam.JPG";
                break;
                
            case 11:
                currentGraph = new DispersionGraph();
                functionName = "images/Eqn191.JPG";
                xAxisImgName = "images/k.JPG";
                yAxisImgName = "images/omega.JPG";
                sliderImageNames = new String[8];
                sliderImageNames[0] = "images/h.JPG";
                sliderImageNames[1] = "images/g.JPG";
                sliderImageNames[2] = "images/Eqn191.JPG";
                sliderImageNames[3] = "images/Eqn191_b.JPG";
                sliderImageNames[4] = "images/kh.JPG";
                sliderImageNames[5] = "images/omegasqrt.JPG";
                sliderImageNames[6] = "images/k.JPG";
                sliderImageNames[7] = "images/omega.JPG";
               break;
         
            case 12:
                currentGraph = new PhaseVelocityGraph();
                functionName = "images/Eqn193.JPG";
                xAxisImgName = "images/k.JPG";
                yAxisImgName = "images/vp.JPG";
                sliderImageNames = new String[8];
                sliderImageNames[0] = "images/h.JPG";
                sliderImageNames[1] = "images/g.JPG";
                sliderImageNames[2] = "images/Eqn193.JPG";
                sliderImageNames[3] = "images/Eqn193_b.JPG";
                sliderImageNames[4] = "images/kh.JPG";
                sliderImageNames[5] = "images/vpoversqrt.JPG";
                sliderImageNames[6] = "images/k.JPG";
                sliderImageNames[7] = "images/vp.JPG";
               break;
           
            case 13:
                currentGraph = new GroupVelocityGraph_dimensional();
                functionName = "images/Eqn194.JPG";
                xAxisImgName = "images/k.JPG";
                yAxisImgName = "images/cg.JPG";
                sliderImageNames = new String[2];
                sliderImageNames[0] = "images/h.JPG";
                sliderImageNames[1] = "images/g.JPG";
                
                break;

            case 131:
                currentGraph = new GroupVelocityGraph_nondimensional();
                functionName = "images/Eqn194_b.JPG";
                xAxisImgName = "images/kh.JPG";
                yAxisImgName = "images/cgoversqrt.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/g.JPG";
                
                break;
                
            case 14:
                currentGraph = new WaveResistanceGraph();
                functionName = "images/vote.gif";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/h.JPG";
                break;
                
            case 15:
                currentGraph = new DispersionRelationGraph();
                functionName = "images/Eqn195.JPG";
                xAxisImgName = "images/k.JPG";
                yAxisImgName = "images/omega.JPG";
                sliderImageNames = new String[8];
                sliderImageNames[0] = "images/h.JPG";
                sliderImageNames[1] = "images/g.JPG"; 
                sliderImageNames[2] = "images/cg.JPG";//not used; just not to have any problems while loading
                sliderImageNames[3] = "images/cgoversqrt.JPG";//not used; just not to have any problems while loading
                sliderImageNames[4] = "images/omegasqrt.JPG";
                sliderImageNames[5] = "images/kh.JPG";
                sliderImageNames[6] = "images/omega.JPG";
                sliderImageNames[7] = "images/k.JPG";
                
                
                
                break;
                
            case 16:
                currentGraph = new ParticleOrbitGraph();
                functionName = "images/vote.gif";
                xAxisImgName = "images/r.JPG";
                yAxisImgName = "images/phi.JPG";
                sliderImageNames = new String[3];
                sliderImageNames[0] = "images/aparam.JPG";
                sliderImageNames[1] = "images/h.JPG";
                sliderImageNames[2] = "images/kparam.JPG";
                
                break;
                
            case 17:
                currentGraph = new IntersectTanhGraph();
                
                functionName = "images/Eqn192.JPG";
                yAxisImgName = "images/c1c2.JPG";
                xAxisImgName = "images/kh.JPG";
                sliderImageNames = new String[3];
                sliderImageNames[0] = "images/h.JPG";
                sliderImageNames[1] = "images/g.JPG";
                sliderImageNames[2] = "images/omegaparam.JPG";
                break;
                
                
            case 18:
                currentGraph = new MunkMomentGraph();
                functionName = "images/Eqn121.JPG";
                xAxisImgName = "images/theta.JPG";
                yAxisImgName = "images/m3.JPG";
                sliderImageNames = new String[3];
                sliderImageNames[0] = "images/m11.JPG";
                sliderImageNames[1] = "images/m22.JPG";
                sliderImageNames[2] = "images/uparam.JPG";
                break;
                
            case 19:
                currentGraph = new UCRGraph();
                
                functionName = "images/Eqn122.JPG";
                xAxisImgName = "images/r.JPG";
                yAxisImgName = "images/phi.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/ia.JPG";
                
                break;
            case 201:
                currentGraph = new ImageMethodGraph_inverse();
                functionName = "images/Eqn111.JPG";
                xAxisImgName = "images/theta.JPG";
                yAxisImgName = "images/vru.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/baparam.JPG";
                break;

            case 20:
                currentGraph = new ImageMethodGraph();
                functionName = "images/Eqn111.JPG";
                xAxisImgName = "images/ba.JPG";
                yAxisImgName = "images/vru.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/thetaparam.JPG";
                break;
                
            case 21:
                currentGraph = new ImageMethod2Graph();
                functionName = "images/Eqn111.JPG";
                xAxisImgName = "images/t.JPG";
                yAxisImgName = "images/vru.JPG";
                sliderImageNames = new String[3];
                sliderImageNames[0] = "images/thetaparam.JPG";
                sliderImageNames[1] = "images/ha.JPG";
                sliderImageNames[2] = "images/N.JPG";
                break;
                                

            case 22:
                currentGraph = new ImageMethodGraph3();
                functionName = "images/Eqn111.JPG";
                xAxisImgName = "images/theta.JPG";
                yAxisImgName = "images/vru.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/tparam.JPG";
                break;                
                
            default:
                currentGraph = new TDSourcePGraph();
                functionName = "images/Eqn101.JPG";
                xAxisImgName = "images/r.JPG";
                yAxisImgName = "images/phi.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/r.JPG";
                
                
                
                break;
        }
        
        
        
        Image img = null;
        if (eqNum!=14) sliderImages = new Image[sliderImageNames.length];
        try {
            img = this.getImage(getCodeBase(), functionName);
            /*if (eqNum!=11)*/ labelFunction.setIcon(new ImageIcon(img));
            
            if (xAxisImgName!=null)
                if (xAxisImgName!="") xAxisImg = this.getImage(getCodeBase(), xAxisImgName);
            if (yAxisImgName!=null) 
                if (yAxisImgName!="") yAxisImg = this.getImage(getCodeBase(), yAxisImgName);
            
            if (eqNum!=14) 
            for(int i=0; i<sliderImageNames.length; i++){
                System.out.println(getCodeBase()+ sliderImageNames[i]);
                sliderImages[i] = this.getImage(getCodeBase(), sliderImageNames[i]);
            }
            
            
        } catch(Exception e){
            e.printStackTrace();
        }
        
        // adds the graph to the graphpanel
//        GraphAreaPanel.add(currentGraph, BorderLayout.CENTER);
        currentGraph.setXAxisImg(xAxisImg);
        currentGraph.setYAxisImg(yAxisImg);
        currentGraph.setSliderImages(sliderImages);
        
        // add options jsliders
        if ((eqNum!=11)&&(eqNum!=12)&&(eqNum!=15)) {
            GraphAreaPanel.add(currentGraph, BorderLayout.CENTER);
            this.getContentPane().add(currentGraph.getOptionsPanel(), BorderLayout.SOUTH);
        }
        else //DispersionGraph or PhaseVelocityGraph or DispersionRelationGraph case
        {
            
        ActionListener aListener = new ActionListener(){
            public void actionPerformed(ActionEvent e){
                gotAction();
            }
        };            
        if (eqNum==11){     ((DispersionGraph)(this.currentGraph)).jButton1.addActionListener(aListener);
                            ((DispersionGraph)(this.currentGraph)).jButton2.addActionListener(aListener);
        }
        if (eqNum==12){     ((PhaseVelocityGraph)(this.currentGraph)).jButton1.addActionListener(aListener);
                            ((PhaseVelocityGraph)(this.currentGraph)).jButton2.addActionListener(aListener);
        }
                            
        if (eqNum==15){     ((DispersionRelationGraph)(this.currentGraph)).jButton1.addActionListener(aListener);
                            ((DispersionRelationGraph)(this.currentGraph)).jButton2.addActionListener(aListener);
        }
            this.getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());
            GraphAreaPanel.add(currentGraph, BorderLayout.CENTER);
            getContentPane().add(FunctionPanel, new org.netbeans.lib.awtextra.AbsoluteConstraints(200, 0, -1, 80));
            getContentPane().add(GraphAreaPanel, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 80, 640, 460));
            getContentPane().add(currentGraph.getOptionsPanel(),new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 540, 640, -1));
        }
        if (eqNum==14) {getContentPane().remove(this.FunctionPanel);System.out.println("removing functionPanel");}
        if (eqNum==15) {getContentPane().remove(this.FunctionPanel);System.out.println("removing functionPanel");}
        if (eqNum==16) {getContentPane().remove(this.FunctionPanel);System.out.println("removing functionPanel");}
        if (eqNum==21) {getContentPane().remove(this.FunctionPanel);System.out.println("removing functionPanel");}
    
    }

    public void gotAction(){
     if (eqNum==11){
        dimensional=((DispersionGraph)(this.currentGraph)).jButton1.isSelected();
            ((DispersionGraph)(this.currentGraph)).jSlider1.setVisible(dimensional);
            ((DispersionGraph)(this.currentGraph)).jSlider2.setVisible(dimensional);
            ((DispersionGraph)(this.currentGraph)).jSlider1.setImageVisible(dimensional);
            ((DispersionGraph)(this.currentGraph)).jSlider2.setImageVisible(dimensional);
        ((DispersionGraph)(this.currentGraph)).jButton1.setBounds(120,0,-1,-1);
        ((DispersionGraph)(this.currentGraph)).jButton2.setBounds(120,20,-1,-1);
        ((DispersionGraph)(this.currentGraph)).restoreDefaults();
                if (dimensional) ((DispersionGraph)(this.currentGraph)).xmax=30;

        if (dimensional) {
            labelFunction.setIcon(new ImageIcon(currentGraph.getSliderImage(2)));
            currentGraph.setXAxisImg(currentGraph.getSliderImage(6));
            currentGraph.setYAxisImg(currentGraph.getSliderImage(7));

        }
        else {
            labelFunction.setIcon(new ImageIcon(currentGraph.getSliderImage(3)));
            currentGraph.setXAxisImg(currentGraph.getSliderImage(4));
            currentGraph.setYAxisImg(currentGraph.getSliderImage(5));
        }
     }
        

     if (eqNum==12){ //PhaseVelocityGraph
        dimensional=((PhaseVelocityGraph)(this.currentGraph)).jButton1.isSelected();
            ((PhaseVelocityGraph)(this.currentGraph)).jSlider1.setVisible(dimensional);
            ((PhaseVelocityGraph)(this.currentGraph)).jSlider2.setVisible(dimensional);
            ((PhaseVelocityGraph)(this.currentGraph)).jSlider1.setImageVisible(dimensional);
            ((PhaseVelocityGraph)(this.currentGraph)).jSlider2.setImageVisible(dimensional);
        ((PhaseVelocityGraph)(this.currentGraph)).jButton1.setBounds(120,0,-1,-1);
        ((PhaseVelocityGraph)(this.currentGraph)).jButton2.setBounds(120,20,-1,-1);
        ((PhaseVelocityGraph)(this.currentGraph)).restoreDefaults();
            
            
        

        if (dimensional) {
            ((PhaseVelocityGraph)(this.currentGraph)).xmax=30;
            labelFunction.setIcon(new ImageIcon(currentGraph.getSliderImage(2)));
            currentGraph.setXAxisImg(currentGraph.getSliderImage(6));
            currentGraph.setYAxisImg(currentGraph.getSliderImage(7));

        }
        else {
            ((PhaseVelocityGraph)(this.currentGraph)).xmax=10;
            labelFunction.setIcon(new ImageIcon(currentGraph.getSliderImage(3)));
            currentGraph.setXAxisImg(currentGraph.getSliderImage(4));
            currentGraph.setYAxisImg(currentGraph.getSliderImage(5));
    }
    }

     
    if (eqNum==15){ //DispersionRelationGraph
        dimensional=((DispersionRelationGraph)(this.currentGraph)).jButton1.isSelected();
            ((DispersionRelationGraph)(this.currentGraph)).jSlider1.setVisible(dimensional);
            ((DispersionRelationGraph)(this.currentGraph)).jSlider1.setImageVisible(dimensional);
            ((DispersionRelationGraph)(this.currentGraph)).jSlider2.setVisible(dimensional);
            ((DispersionRelationGraph)(this.currentGraph)).jSlider2.setImageVisible(dimensional);
        ((DispersionRelationGraph)(this.currentGraph)).jButton1.setBounds(120,0,-1,-1);
        ((DispersionRelationGraph)(this.currentGraph)).jButton2.setBounds(120,20,-1,-1);
        ((DispersionRelationGraph)(this.currentGraph)).restoreDefaults();
            
            
        

        if (dimensional) {
            currentGraph.setXAxisImg(currentGraph.getSliderImage(6));
            currentGraph.setYAxisImg(currentGraph.getSliderImage(7));

        }
        else {
            currentGraph.setXAxisImg(currentGraph.getSliderImage(4));
            currentGraph.setYAxisImg(currentGraph.getSliderImage(5));
    }
    }     
        
     this.repaint();   
    }
    
    public void start(){
    }
    public void stop(){
    }
        
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        FunctionPanel = new javax.swing.JPanel();
        labelFunction = new javax.swing.JLabel();
        GraphAreaPanel = new javax.swing.JPanel();

        setBackground(new java.awt.Color(204, 204, 204));
        FunctionPanel.add(labelFunction);

        getContentPane().add(FunctionPanel, java.awt.BorderLayout.NORTH);

        GraphAreaPanel.setLayout(new java.awt.BorderLayout());

        getContentPane().add(GraphAreaPanel, java.awt.BorderLayout.CENTER);

    }//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel labelFunction;
    private javax.swing.JPanel FunctionPanel;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel GraphAreaPanel;
    // End of variables declaration//GEN-END:variables
    
    private ChangeListener listener;
    public int eqNum;
    public boolean dimensional=true;
        Image xAxisImg = null;
        Image yAxisImg = null;
        Image[] sliderImages;
}
