/*
 * DispersionGraph.java
 *
 * Created on March 11, 2003, 1:47 AM
 */

package graphs;

/**
 *
 * @author  Ravi
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;

public class DispersionGraph extends DoubleSliderGraph{
    
    /** Creates a new instance of TDSourceVGraph */
    public DispersionGraph() {
/*        ActionListener aListener = new ActionListener(){
            public void actionPerformed(ActionEvent e){
                gotAction();
            }
        };
        ItemListener iListener = new ItemListener(){
            public void itemStateChanged(ItemEvent e){
                gotAction();
            }
        };
*/        jSlider1.setMinimum(0);
        jSlider2.setMinimum(0);
        jSlider1.setMaximum(100000);
        jSlider2.setMaximum(20000);
        p1=0;
        p2=0;
        jSlider1.setMajorTickSpacing(20000);
        jSlider1.setMinorTickSpacing(10000);
        Hashtable labelTable = new Hashtable();
        for (int i=0; i<=100;i+=20)
        labelTable.put( new Integer( i*1000 ), new JLabel(Integer.toString(i)) );
        jSlider1.setLabelTable(labelTable);
        
        jButton1 = new JRadioButton("Dimensional Version");
        jButton2 = new JRadioButton("Non-Dimensional Version");
        jButton1.setSelected(true);

        ButtonGroup group = new ButtonGroup();
        group.add(jButton1);
        group.add(jButton2);
     
    }
    
    public JPanel getOptionsPanel() {
        jPanel = new JPanel();
        innerPanel = new JPanel();
        innerPanel.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());
        
        jSlider1.setImage(this.getSliderImage(0));
        jSlider2.setImage(this.getSliderImage(1)); // to be changed in order to have the equation image as well
        
        innerPanel.add(jButton1,new org.netbeans.lib.awtextra.AbsoluteConstraints(120, 0, -1, -1));
        innerPanel.add(jButton2,new org.netbeans.lib.awtextra.AbsoluteConstraints(120, 20, -1, -1));
        innerPanel.add(jSlider1.getContainer(),new org.netbeans.lib.awtextra.AbsoluteConstraints(80, 40, -1, -1));
        innerPanel.add(jSlider2.getContainer(),new org.netbeans.lib.awtextra.AbsoluteConstraints(80, 93, -1, -1));
        
        jPanel.add(innerPanel);
        return jPanel; 
    }    
    
    
    
    
        public void restoreDefaults(){
        xmin=0.0001;
        xmax=10;
        ymin=-5;
        ymax=5;
        p1=0;
        p2=0;
        super.restoreDefaults();
    }
    
    public Polygon computePolygon(double xMin, double xMax, double yOffset) {
        Polygon grapher = new Polygon();
        
        double[][] xy=new double[4*this.getWidth()][2];
        //        double min=0d, max=0d;
        System.out.println("p1:"+p1);
        xScale=this.getWidth()/(xmax-xmin); System.out.println("xScale:"+xScale);
        yScale=this.getHeight()/(ymax-ymin); System.out.println("yScale:"+yScale);
        for (double i = 0; i < this.getWidth(); i += DI){
            // build array of x and y, then find min and max
            xy[(int)(4*i)][0] = xMin+i*(xMax-xMin)/width; //current value on x-axis, in numbers, not pixels
//            xy[(int)(4*i)][1] = Math.pow(  p2 * xy[(int)(4*i)][0] * ( Math.pow(2.718281828459045, 2.0*xy[(int)(4*i)][0] * p1) -1.0)    /  ( Math.pow(2.718281828459045, 2.0*xy[(int)(4*i)][0] * p1) + 1.0)             , .5); //current value of function, in numbers
            if (this.jButton1.isSelected()) xy[(int)(4*i)][1] = Math.sqrt(p2*xy[(int)(4*i)][0]*(Math.exp(p1*xy[(int)(4*i)][0])-Math.exp(-p1*xy[(int)(4*i)][0]))/(Math.exp(p1*xy[(int)(4*i)][0])+Math.exp(-p1*xy[(int)(4*i)][0])));
            else xy[(int)(4*i)][1] = xy[(int)(4*i)][0]*(Math.exp(xy[(int)(4*i)][0])-Math.exp(-xy[(int)(4*i)][0]))/(Math.exp(xy[(int)(4*i)][0])+Math.exp(xy[(int)(4*i)][0])); // omega^2*h/g
        }
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double j = -yScale * xy[(int)(4*i)][1] + yOffset; //current value of function, in pixels
//            System.out.println("am here");
            System.out.println("("+xy[(int)(4*i)][0]+","+xy[(int)(4*i)][1]+")");
            grapher.addPoint((int) i, (int) j);
        }
        return grapher;
    }
        
    

    
    public Polygon[] computePolygonArray(double xMin, double xMax, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon(xMin, xMax, yOffset);
        return polyArray;
    }
    
    
    
    
    
    
    
    
    
    public Polygon[] computePolygonArray(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon(xScale, xOffset, yScale, yOffset);
        return polyArray;
    }
    public Polygon computePolygon(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon grapher = new Polygon();
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double x = (i-xOffset)/xScale;
            double y = Math.pow(  p2 * x * ( Math.pow(2.718281828459045, 2.0*x * p1) -1.0)    /  ( Math.pow(2.718281828459045, 2.0*x * p1) + 1.0)             , .5);
            double j = yScale * y + yOffset;
            //System.out.print("("+x+","+y+")");
            grapher.addPoint((int) i, (int) j);
        }
        
        return grapher;
    }
    
public JRadioButton jButton1, jButton2;    
    boolean dimensional=true, firstRun=false;
    
public JPanel jPanel,innerPanel1,innerPanel2;
    
}
