/*
 * DispersionRelationGraph.java
 *
 * Created on March 11, 2003, 10:00 PM
 */

package graphs;

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;

/**
 *
 * @author  Ravi
 *
 *
 */
public class DispersionRelationGraph extends DoubleSliderGraph {
    
    private double y;
    /** Creates a new instance of DispersionRelationGraph */
    public DispersionRelationGraph() {
        jSlider1.setMinimum(0);
        jSlider1.setMaximum(100000);
        jSlider2.setMinimum(0);
        jSlider2.setMaximum(20000);
        jSlider1.setValue(10000);
        jSlider2.setValue(10000);
        jSlider1.setMajorTickSpacing(20000);
        jSlider1.setMinorTickSpacing(10000);
        jSlider2.setMajorTickSpacing(5000);
        jSlider2.setMinorTickSpacing(1000);
        Hashtable labelTable1 = new Hashtable();
        for (int i=0; i<=100;i+=20)
        labelTable1.put( new Integer( i*1000 ), new JLabel(Integer.toString(i)) );
        jSlider1.setLabelTable(labelTable1);        
        
        Hashtable labelTable2 = new Hashtable();
        for (int i=0; i<=20;i+=5)
        labelTable2.put( new Integer( i*1000 ), new JLabel(Integer.toString(i)) );
        jSlider2.setLabelTable(labelTable2);        
    
        jButton1 = new JRadioButton("Dimensional Version");
        jButton2 = new JRadioButton("Non-Dimensional Version");
        jButton1.setSelected(true);

        ButtonGroup group = new ButtonGroup();
        group.add(jButton1);
        group.add(jButton2);
    }
    
    

    
    public Polygon computePolygon(double xMin, double xMax, double yOffset) {
        Polygon grapher = new Polygon();
        
        double[][] xy=new double[4*this.getWidth()][2];
        
   
        xScale=this.getWidth()/(xmax-xmin); System.out.println("xScale:"+xScale);
        yScale=this.getHeight()/(ymax-ymin); System.out.println("yScale:"+yScale);
        System.out.println("commencing graph");
        
        if (this.jButton1.isSelected()) //dimensional
        for (double i = 0; i < this.getWidth(); i += DI){
            // build array of x and y, then find min and max
            xy[(int)(4*i)][0] = xMin+i*(xMax-xMin)/width; //current value on x-axis, in numbers, not pixels
//       if ( xy[(int)(4*i)][0]*xy[(int)(4*i)][0] * p1 / p2  < 2) {
        
            double c=Math.pow(xy[(int)(4*i)][0],2)*p1/p2;
// c>2 y=c((1+2*exp(-2c)-12*exp(-4c))
// c<2 y=sqrt(c)*(1+0.169*c+0.031*c^2)

	    if ( c  < 2) {                


//                xy[(int)(4*i)][1] = Math.pow(xy[(int)(4*i)][0] * xy[(int)(4*i)][0] / (p1 * p2), .5) * (1.0 + 0.169 * xy[(int)(4*i)][0] * xy[(int)(4*i)][0]  * p1 / p2 + 0.031 * (xy[(int)(4*i)][0] * xy[(int)(4*i)][0]  * p1 / p2) * (xy[(int)(4*i)][0] * xy[(int)(4*i)][0]  * p1 / p2));
                xy[(int)(4*i)][1] = Math.sqrt(c)*(1.0d+0.169*c+0.031*c*c); 
                }
            else {
//                xy[(int)(4*i)][1] = xy[(int)(4*i)][0] * xy[(int)(4*i)][0] / p2 * (1.0 + 2.0 * Math.pow(2.718281828459045, -2*(xy[(int)(4*i)][0] * xy[(int)(4*i)][0]  * p1 / p2)) - 12.0 * Math.pow(2.718281828459045, -4.0 * (xy[(int)(4*i)][0] * xy[(int)(4*i)][0]  * p1 / p2)));
                xy[(int)(4*i)][1] = c*(1+2*Math.exp(-2*c)-12*Math.exp(-4*c));
            }
        }
            
        
        else // non-dimensional
        for (double i = 0; i < this.getWidth(); i += DI){
            xy[(int)(4*i)][0] = xMin+i*(xMax-xMin)/width; //current value on x-axis, in numbers, not pixels
            double c = xy[(int)(4*i)][0];
            if ( (c/width/*/width*(xMax-xMin)-xMin*/)  < 2) {                
                xy[(int)(4*i)][1] = Math.sqrt(c) * (1.0 + 0.169 * c + 0.031 * c * c);            }
            else {
                xy[(int)(4*i)][1] = c * (1.0 + 2.0 * Math.exp(-2 * c) - 12.0 * Math.exp(-4.0 * c));
            }
        }
            
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double j = -yScale * xy[(int)(4*i)][1] + yOffset; //current value of function, in pixels
//            System.out.println("("+xy[(int)(4*i)][0]+","+xy[(int)(4*i)][1]+")");
            grapher.addPoint((int) i, (int) j);
        }
        return grapher;
}
        
    

    
    public Polygon[] computePolygonArray(double xMin, double xMax, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon(xMin, xMax, yOffset);
        return polyArray;
    }
    
    public JPanel getOptionsPanel() {
        jPanel = new JPanel();
        innerPanel = new JPanel();
        innerPanel.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());
        
        jSlider1.setImage(this.getSliderImage(0));
        jSlider2.setImage(this.getSliderImage(1)); // to be changed in order to have the equation image as well
        
        innerPanel.add(jButton1,new org.netbeans.lib.awtextra.AbsoluteConstraints(120, 0, -1, -1));
        innerPanel.add(jButton2,new org.netbeans.lib.awtextra.AbsoluteConstraints(120, 20, -1, -1));
        innerPanel.add(jSlider1.getContainer(),new org.netbeans.lib.awtextra.AbsoluteConstraints(80, 40, -1, -1));
        innerPanel.add(jSlider2.getContainer(),new org.netbeans.lib.awtextra.AbsoluteConstraints(80, 93, -1, -1));
        
        jPanel.add(innerPanel);
        return jPanel; 
    }        
    

    public void restoreDefaults(){
        xmin=0.0001;
        xmax=5;
        ymin=-10;
        ymax=10;
        p1=10;
        p2=10;
        super.restoreDefaults();
    }    
    
    
    public Polygon[] computePolygonArray(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon(xScale, xOffset, yScale, yOffset);
        return polyArray;
    }
    public Polygon computePolygon(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon grapher = new Polygon();
        
        for (double i = 0; i < this.getWidth(); i += DI){
           
            double x = (i-xOffset)/xScale;
            double y = Math.pow(  p2 / x * ( Math.pow(2.718281828459045, 2.0*x * p1) -1.0)    /  ( Math.pow(2.718281828459045, 2.0*x * p1) + 1.0)             , .5);
            double j = yScale * y + yOffset;
            //System.out.print("("+x+","+y+")");
            grapher.addPoint((int) i, (int) j);
            
        }
        
        return grapher;
    }
public JRadioButton jButton1, jButton2;    
    boolean dimensional=true, firstRun=false;
    
public JPanel jPanel,innerPanel1,innerPanel2;    
}
    
