package graphs;

/*
 * GraphPanel.java
 *
 * Created on March 9, 2003, 5:30 PM
 */

/**
 *
 * @author  Ravi
 */

import javax.swing.*;
import java.awt.*;

public abstract class GraphPanel extends javax.swing.JPanel{
    protected static final double DI = 0.25;
    public int mode=0;
    public Image xAxisImg = null;
    public Image yAxisImg = null;
    public Image[] sliderImages = null;
    private Color[] graphColors = {Color.red, Color.blue, Color.white};
    
    
    /** Creates new form GraphPanel */
    public GraphPanel() {
        xmin = 0;
        xmax = 20.0;
        ymin = -10.0;
        ymax = 10.0;
        restoreDefaults();
        
        initComponents();
  
       
        }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents

        setLayout(new java.awt.BorderLayout());

        setBackground(new java.awt.Color(0, 255, 255));
        setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 51, 204)));
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                formMousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                formMouseReleased(evt);
            }
        });

        addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                formMouseDragged(evt);
            }
        });

    }//GEN-END:initComponents

    private void formMouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseDragged
//            System.out.println("dragging; pressed_x="+pressed.x+" and pressed_y="+pressed.y);
            r=new Rectangle(Math.min(pressed.x,evt.getPoint().x),Math.min(pressed.y,evt.getPoint().y),Math.abs(pressed.x-evt.getPoint().x),Math.abs(pressed.y-evt.getPoint().y));
            fromZoom=true;
            this.repaint();
//            pressed=null;
//            r=null;
    }//GEN-LAST:event_formMouseDragged

    private void formMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseReleased
    if ((evt.getButton()==1)&&(evt.getClickCount()<2)&&(!evt.getPoint().equals(pressed))){
        r=new Rectangle(pressed,new Dimension((int)Math.abs(evt.getPoint().x-pressed.x),(int)Math.abs(evt.getPoint().y-pressed.y)));
/*        System.out.println("r.x="+r.x);
        System.out.println("r.y="+r.y);
        System.out.println("r.width="+r.width);
        System.out.println("r.height="+r.height);
        oldmax=ymax;oldmin=ymin;
        this.ymin=ymax-r.getMaxY()/yScale;System.out.println("ymin:"+ymin);
        this.ymax=ymax-r.getMinY()/yScale;System.out.println("ymax:"+ymax);
        this.xmin=r.getMinX()/xScale;System.out.println("xmin:"+xmin);
        this.xmax=r.getMaxX()/xScale;System.out.println("xmax:"+xmax);
    //        yOffset=(int)(yOffset*height/(yScale*(ymax-ymin)*r.height));
        fromZoom=true;
*/
        this.repaint();
        r=null;pressed=null;
    }
    }//GEN-LAST:event_formMouseReleased

    private void formMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMousePressed
    r=null;
    this.repaint();
    if ((evt.getButton()==1)&&(evt.getClickCount()>=2)) zoomIn();
    else if (evt.getButton()==3) zoomOut();
    else if (evt.getButton()==2) {restoreDefaults();repaint();}
        else {pressed=evt.getPoint();System.out.println("mouse pressed");}
    }//GEN-LAST:event_formMousePressed
    
    public void zoomIn(){
        fromZoom=true;
        
        xmax=xmax/2;
        xmin=xmin/2;
        ymax=ymax/2;
        ymin=ymin/2; //finished applying transf

        
        repaint();
    }  

    public void zoomOut(){
        fromZoom=true;
        xmax=xmax*2;
        xmin=xmin*2;
        ymax=ymax*2;
        ymin=ymin*2;
        repaint();
    }  
    
    public void setXAxisImg(Image xAxisImg){
        this.xAxisImg = xAxisImg;
    }
    public void setYAxisImg(Image yAxisImg){
        this.yAxisImg = yAxisImg;
    }
    public void setSliderImages(Image[] sliderImages){
        this.sliderImages = sliderImages;
    }
    public Image getSliderImage(int n){
        return sliderImages[n];
    }
    
    public void restoreDefaults() {
        // offsets/scales
        width = getWidth();
        height = getHeight();
        xScale = width / (xmax-xmin);
        xOffset = 0;
//        yScale = -height/(2.0*(ymax-ymin));
//        yOffset = height/2.0;
        yScale = -height/(ymax-ymin);
        yOffset = height/2.0;
        }
    
    public void paintComponent(Graphics gr){
        
        if (firsttime) { 
            restoreDefaults(); 
            firsttime=false;
        }
        
        gr.setColor(getBackground());
        gr.fillRect(0,0,width, height);
        gr.setColor(Color.black);
        
//        System.out.println("xScale="+xScale+" xOffset="+xOffset+"yScale="+yScale+" yOffset="+yOffset);
//        System.out.println("p1="+p1);
        
        // axis y left, x middle
        gr.drawLine(0, 0, 0, height);
        gr.drawLine(0, (int)yOffset, width , (int)yOffset);
        fromZoom=false;
        if (xAxisImg!=null) gr.drawImage(xAxisImg, width - xAxisImg.getWidth(this), height / 2 - xAxisImg.getHeight(this), this);
        if (yAxisImg!=null) gr.drawImage(yAxisImg, 5, 5, this);
        
        
        int scalebitch=1;
        if (ymax-ymin>10) scalebitch=2;
        if (ymax-ymin>25) scalebitch=4;        
        if (ymax-ymin>30) scalebitch=5;
        if (ymax-ymin>50) scalebitch=10;
        //System.out.println("");
        System.out.println("start");
//        Polygon[] grapher = computePolygonArray(xScale, xOffset, yScale, yOffset);
        System.out.println("xmin:"+xmin+" xmax:"+xmax+" yOffset"+yOffset);
        Polygon[] grapher = computePolygonArray(xmin, xmax, yOffset);

        int m=scalebitch;
//        System.out.println(yScale);
        for (int j=height/2;j<height;j++)
            if ((j-height/2)/(yScale)>=m){
                if ((ymax-m)==0)m+=scalebitch;
                else {
                gr.setColor(Color.black);
                gr.drawString(Integer.toString((int)(-m)),7,j);
                gr.setColor(Color.yellow);
                if (((int)(j/(-yScale))-(int)ymax)!=0) gr.drawLine(0,j,width,j);
//                System.out.println("writing scale: "+(-m));
                m+=scalebitch;}
            }
//        m=1;
        

        m=scalebitch;
// replace height/2 with zero_line_coord, in order to move x-axis up and down
        
//        System.out.println(yScale);
        
        for (int j=height/2;j>0;j--)
            if ((height/2-j)/(yScale)>=m){
                if ((ymax-m)==0)m+=scalebitch;
                else {
                    gr.setColor(Color.black);
                gr.drawString(Integer.toString((int)(m)),7,j);
                gr.setColor(Color.yellow);
                if ((((int)(j/(-yScale))-(int)ymax)!=0)) gr.drawLine(0,j,width,j);
                 gr.drawLine(0,j,width,j);
//                System.out.println("writing scale: "+(-m));
                m+=scalebitch;}
            }        
       
        if (!(r==null)) {
            System.out.println("drawing rectangle");
            gr.setXORMode(this.getBackground());
            gr.fillRect(r.x,r.y,r.width,r.height);
            gr.setXORMode(this.getBackground());
        }
        
/*        if (mode==0)*/{
//        int scaleplus=(int)(xmax-xmin)/10, scale=scaleplus;
        
        int scaleplus=5;
        if (!drawPi){
        if ((xmax-xmin)<20) scaleplus=2;
        if ((xmax-xmin)<10) scaleplus=1;
        int scale=scaleplus;
        for (int i=0;i<grapher[0].xpoints.length;i++){
            if ((int)((i-xOffset)/xScale)>=width*4/xScale) break;
            if ((((int)((i/4-xOffset)/xScale))==scale)&&(((int)((i/4-xOffset)/xScale))!=0)&&(grapher[0].xpoints[i]<=width)){
//            System.out.println("xScale:"+xScale+ "i:"+i);
            scale+=scaleplus;
            gr.setColor(Color.black);
            gr.drawString(Integer.toString((int)((i/4-xOffset)/xScale)+Math.round((float)xmin)),grapher[0].xpoints[i],height/2+20);
            gr.drawLine(grapher[0].xpoints[i],height/2-3,grapher[0].xpoints[i],height/2+3); //xscale=how many pixels per unit of x
            gr.setColor(Color.yellow);
            gr.drawLine(grapher[0].xpoints[i],0,grapher[0].xpoints[i],height/2-3);
            gr.drawLine(grapher[0].xpoints[i],height/2+3,grapher[0].xpoints[i],height);
            }
        }
         gr.setColor(Color.black);
         if ((xmin>0)&&(xmin<.001)) gr.drawString("0",5,height/2-1);
         else gr.drawString(Double.toString(xmin),5,height/2-1);
         gr.drawString(Double.toString(xmax),width-25,height/2+20);

        
        
        }

        else // in drawPi mode
        {
            
        scaleplus=2;
        if ((xmax-xmin)<10) scaleplus=1;
        int scale=0; //first value on scale
//        int scale=(int)(2*xmin/3.14159);
        
        
        if (UCRGraf) {
//         scale=(int)(2*xmin/3.14159);   
         scale=0;int deviation=(int)(2*xmin/3.14159);
         System.out.println("Scale e: "+scale);
  
         
         
        for (int i=0;i<grapher[0].xpoints.length;i++){
            if ((int)((i-xOffset)/xScale)>=(width*4/xScale)) break;
            if (((((i/4-xOffset)/xScale))>=(scale*3.14159/2))&&((((i/4-xOffset)/xScale))!=0)&&(grapher[0].xpoints[i]<=width)){
            gr.setColor(Color.black);
            if (scale+deviation==0) gr.drawString("0",grapher[0].xpoints[i]-3,height/2+20); else
            if (scale%2==0) {
            if (scale+deviation==2) gr.drawString("\u03c0",grapher[0].xpoints[i]-17,height/2+20);
            else             if (scale+deviation==-2) gr.drawString("-\u03c0",grapher[0].xpoints[i]-17,height/2+20);
            else gr.drawString((int)((scale+deviation)/2)+"\u03c0",grapher[0].xpoints[i]-17,height/2+20);
            }
            else 
                if (scale+deviation==1) gr.drawString("\u03c0/2",grapher[0].xpoints[i]-17,height/2+20);
                else                 if (scale+deviation==-1) gr.drawString("-\u03c0/2",grapher[0].xpoints[i]-17,height/2+20);
                    else gr.drawString((int)(scale+deviation)+"\u03c0/2",grapher[0].xpoints[i]-17,height/2+20);
            scale+=scaleplus;
            gr.drawLine(grapher[0].xpoints[i],height/2-3,grapher[0].xpoints[i],height/2+3); //xscale=how many pixels per unit of x
            gr.setColor(Color.yellow);
            gr.drawLine(grapher[0].xpoints[i],0,grapher[0].xpoints[i],height/2-3);
            gr.drawLine(grapher[0].xpoints[i],height/2+3,grapher[0].xpoints[i],height);

        }
        }
         
         gr.setColor(Color.black);
         if ((int)(2*xmin/3.14159)==-1) gr.drawString("-\u03c0/2",/*grapher[0].xpoints[grapher[0].xpoints.length-1]*/+5,height/2-1);
         else if ((int)(2*xmin/3.14159)==-2) gr.drawString("-\u03c0",/*grapher[0].xpoints[grapher[0].xpoints.length-1]*/+5,height/2-1);
                else if ((int)((2*xmin/3.14159))%2==0) gr.drawString((int)(xmin/3.14159)+"\u03c0",/*grapher[0].xpoints[grapher[0].xpoints.length-1]+*/5,height/2-1);
                    else gr.drawString((int)(2*xmin/3.14159)+"\u03c0/2",/*grapher[0].xpoints[grapher[0].xpoints.length-1]+*/5,height/2-1);
         if ((int)(2*xmax/3.14159)==1) gr.drawString("\u03c0/2",width-25,height/2+20);
         else if ((int)(2*xmax/3.14159)==2) gr.drawString("\u03c0",width-15,height/2+20);
                else if ((int)((2*xmax/3.14159)%2)==0) gr.drawString((int)(xmax/3.14159)+"\u03c0",width-15,height/2+20);
         else gr.drawString((int)(2*xmax/3.14159)+"\u03c0/2",width-25,height/2+20);
         
           
         
        }
        
        
        
        
        
        
        else //not in UCRGraf mode anymore
        {
        for (int i=0;i<grapher[0].xpoints.length;i++){
            if ((int)((i-xOffset)/xScale)>=(width*4/xScale)) break;
            if (((((i/4-xOffset)/xScale))>=(scale*3.14159/2))&&((((i/4-xOffset)/xScale))!=0)&&(grapher[0].xpoints[i]<=width)){
            gr.setColor(Color.black);
            if (scale==0) ; else
            if (scale%2==0) {
            if (scale==2) gr.drawString("\u03c0",grapher[0].xpoints[i]-17,height/2+20);
            else gr.drawString((int)(scale/2)+"\u03c0",grapher[0].xpoints[i]-17,height/2+20);
            }
            else 
                if (scale==1) gr.drawString("\u03c0/2",grapher[0].xpoints[i]-17,height/2+20);
                    else gr.drawString(scale+"\u03c0/2",grapher[0].xpoints[i]-17,height/2+20);
            scale+=scaleplus;
            gr.drawLine(grapher[0].xpoints[i],height/2-3,grapher[0].xpoints[i],height/2+3); //xscale=how many pixels per unit of x
            gr.setColor(Color.yellow);
            gr.drawLine(grapher[0].xpoints[i],0,grapher[0].xpoints[i],height/2-3);
            gr.drawLine(grapher[0].xpoints[i],height/2+3,grapher[0].xpoints[i],height);

        }
        }
                 gr.setColor(Color.black);
         if ((xmin>0)&&(xmin<.001)) gr.drawString("0",5,height/2-1);
         else gr.drawString(Double.toString(xmin),5,height/2-1);
                  if ((int)(2*xmax/3.14159)==1) gr.drawString("\u03c0/2",width-25,height/2+20);
         else if ((int)(2*xmax/3.14159)==2) gr.drawString("\u03c0",width-15,height/2+20);
                else if ((int)((2*xmax/3.14159)%2)==0) gr.drawString((int)(xmax/3.14159)+"\u03c0",width-15,height/2+20);
         else gr.drawString((int)(2*xmax/3.14159)+"\u03c0/2",width-25,height/2+20);
        }

        
        }
            
            
            
            
            
            
            
            


        
        
/*        
        for (int j=0;j<height/2;j++)
            if ((height/2-j)/(yScale)>=m){
                if ((ymax-m)==0)m++;
                else {
                gr.setColor(Color.black);
                gr.drawString(Integer.toString((int)(ymax-m)),7,j);
                gr.setColor(Color.yellow);
                if (((int)(j/(-yScale))-(int)ymax)!=0) gr.drawLine(0,j,width,j);
                System.out.println("writing scale: "+(ymax-m));
                m++;}
            }
*/        
        gr.drawString(Double.toString(ymax),5,15); System.out.println("drawing ymin");
        gr.drawString(Double.toString(ymin),5,height-2); System.out.println("drawing ymax");


        
        
}

        for(int i=0; i<grapher.length; i++){
            gr.setColor(graphColors[i%graphColors.length]);
            gr.drawPolyline(grapher[i].xpoints, grapher[i].ypoints, grapher[i].npoints);
        }

    }

    public static double sinh(double myAngle) {
          double sinh = (Math.exp(myAngle)-Math.exp(-myAngle))/2;
          return sinh;
     }
     public static double cosh(double myAngle) {
          double cosh = (Math.exp(myAngle)+Math.exp(-myAngle))/2;
          return cosh;
     }
     public static double tanh(double myAngle) {
          double tanh = sinh(myAngle)/cosh(myAngle);
          return tanh;
     }        
    
//    public double cosh(double x) {return (Math.exp(x)+Math.exp(-x))/2;}
    public double sech(double x) {return (1/cosh(x));}
    
    public abstract Polygon[] computePolygonArray(double xScale, double xOffset, double yScale, double yOffset);
    public abstract Polygon[] computePolygonArray(double xMin, double xMax, double yOffset);
    public abstract JPanel getOptionsPanel();
//    public abstract void restoreDefaults();
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    
    public void SetParam(double Ip1){
        System.out.println("SetParam(). p1="+p1);
        p1 = Ip1;
        repaint();
    }
    
    public double GetParam(){
        return p1;
    }
    public void SetParam2(double Ip1, double Ip2){
        //System.out.println("p1="+p1);
        p1 = Ip1;
        p2 = Ip2;
        repaint();
    }
    
    public void SetParam3(double Ip1, double Ip2, double Ip3){
        p1 = Ip1;
        p2 = Ip2;
        p3 = Ip3;
        repaint();
    }
    public void SetParam5(double Ip1, double Ip2, double Ip3, double Ip4, double Ip5){
        p1 = Ip1;
        p2 = Ip2;
        p3 = Ip3;
        p4 = Ip4;
        p5 = Ip5;
        repaint();
        
    }
    
    public void SetParam6(double Ip1, double Ip2, double Ip3, double Ip4, double Ip5, double Ip6){
        p1 = Ip1;
        p2 = Ip2;
        p3 = Ip3;
        p4 = Ip4;
        p5 = Ip5;
        p6 = Ip6;
        repaint();
        
    }
    
        int width;
        int height;
        
    private Point pressed;
    private Rectangle r;
    public boolean firsttime=true;
    private int equnum;
    public boolean drawPi=false, munkMoment=false;
    private boolean fromZoom=false;
    boolean UCRGraf=false;
    public int positionXaxis;
    protected double p1 = 1;
    protected double p2 = 1;
    protected double p3 = 1;
    protected double p4 = 1;
    protected double p5 = 1;
    protected double p6 = 1;
    public double xmin, xmax, ymin, ymax, xScale, yScale, xOffset, yOffset, oldmax, oldmin;
}
