package graphs;

/*
 * SinGraph.java
 *
 * Created on March 10, 2003, 9:52 PM
 */

/**
 *
 * @author  Ravi
 */
import java.awt.*;
import javax.swing.*;
import java.util.*;

public class ImageMethodGraph extends SingleSliderGraph{
    
    /** Creates a new instance of SinGraph */
    public ImageMethodGraph() {
        jSlider.setMinimum(0);
        jSlider.setMaximum(4000);
        jSlider.setValue(0);
        jSlider.setMajorTickSpacing(1000);
        jSlider.setMinorTickSpacing(500);
        Hashtable labelTable = new Hashtable();
        for (int i=0; i<=4;i+=1)
        switch (i) {
            case 0: {labelTable.put(new Integer( 0 ), new JLabel(Integer.toString(i)) );break;}
            case 1: {labelTable.put(new Integer( i*1000 ), new JLabel("\u03c0/2") );break;}
            case 2: {labelTable.put(new Integer( i*1000 ), new JLabel("\u03c0") );break;}
            case 3: {labelTable.put(new Integer( i*1000 ), new JLabel("3\u03c0/2") );break;}
            case 4: {labelTable.put(new Integer( 4000 ), new JLabel("2\u03c0") );}
        } 
        jSlider.setLabelTable(labelTable);        
    }

    public void restoreDefaults(){
        xmin=1;
        xmax=5;
        ymin=-1;
        ymax=1;
        super.restoreDefaults();
    }    

    public Polygon computePolygon(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon grapher = new Polygon();
//        double p = Math.cos(p1);
//        double q = Math.sin(p1);
        double t = p2*Math.PI;
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double x = (i-xOffset)/xScale;
//            double p = Math.cos(xy[(int)(4*i)][0]);
//            double q = Math.sin(xy[(int)(4*i)][0]);
//            double y = p*(4*t*t-1)/((p*p+(q+2*t)*(q+2*t))*(p*p+(q+2*t)*(q+2*t)));
            double y=0;
            double j = yScale * y + yOffset;
            //System.out.print("("+x+","+y+")");
            grapher.addPoint((int) i, (int) j);
        }
        
        return grapher;
    }
    
    public Polygon computePolygon(double xMin, double xMax, double yOffset) {
        Polygon grapher = new Polygon();
        
        double[][] xy=new double[4*this.getWidth()][2];
        double theta = p1/2*Math.PI;
        //        double min=0d, max=0d;
        System.out.println("p1:"+p1);
        xScale=this.getWidth()/(xmax-xmin); System.out.println("xScale:"+xScale);
        yScale=this.getHeight()/(ymax-ymin); System.out.println("yScale:"+yScale);
        for (double i = 0; i < this.getWidth(); i += DI){
            // build array of x and y, then find min and max
            xy[(int)(4*i)][0] = xMin+i*(xMax-xMin)/width; //current value on x-axis, in numbers, not pixels
            double p = Math.cos(theta);
            double q = Math.sin(theta);
            xy[(int)(4*i)][1] = p*(4*xy[(int)(4*i)][0]*xy[(int)(4*i)][0]-1)/Math.pow(p*p+(q+2*xy[(int)(4*i)][0])*(q+2*xy[(int)(4*i)][0]),2); //current value of function, in numbers
        }//p*(4*t^2-1)/[p^2+(q+2*t)^2]^2
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double j = -yScale * xy[(int)(4*i)][1] + yOffset; //current value of function, in pixels
//            System.out.println("am here");
//            System.out.println("("+xy[(int)(4*i)][0]+","+xy[(int)(4*i)][1]+")");
            grapher.addPoint((int) i, (int) j);
        }
        return grapher;
    }    
    
    
    
    public Polygon[] computePolygonArray(double xMin, double xMax, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon(xMin, xMax, yOffset);
        return polyArray;
    }    
    
    public Polygon[] computePolygonArray(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon(xScale, xOffset, yScale, yOffset);
        return polyArray;
    }
}
