package graphs;

/*
 * SinGraph.java
 *
 * Created on March 10, 2003, 9:52 PM
 */

/**
 *
 * @author  Ravi
 */
import java.awt.*;
import javax.swing.*;
import java.util.*;

public class ImageMethodGraph_inverse extends SingleSliderGraph{
    
    /** Creates a new instance of SinGraph */
    public ImageMethodGraph_inverse() {
        jSlider.setMinimum(1000);
        drawPi=true;
        jSlider.setMaximum(5000);
        jSlider.setValue(1000);
        jSlider.setMajorTickSpacing(1000);
        jSlider.setMinorTickSpacing(500);
        Hashtable labelTable = new Hashtable();
        for (int i=1; i<=5;i+=1)
        labelTable.put( new Integer( i*1000 ), new JLabel(Integer.toString(i)) );
        jSlider.setLabelTable(labelTable);        
    }

    public void restoreDefaults(){
        xmin=0;
        xmax=2*3.14159;
        ymin=-1;
        ymax=1;
        super.restoreDefaults();
    }    

    public Polygon computePolygon(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon grapher = new Polygon();
//        double p = Math.cos(p1);
//        double q = Math.sin(p1);
        double t = p2;
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double x = (i-xOffset)/xScale;
//            double p = Math.cos(xy[(int)(4*i)][0]);
//            double q = Math.sin(xy[(int)(4*i)][0]);
//            double y = p*(4*t*t-1)/((p*p+(q+2*t)*(q+2*t))*(p*p+(q+2*t)*(q+2*t)));
            double y=0;
            double j = yScale * y + yOffset;
            //System.out.print("("+x+","+y+")");
            grapher.addPoint((int) i, (int) j);
        }
        
        return grapher;
    }
    
    public Polygon computePolygon(double xMin, double xMax, double yOffset) {
        Polygon grapher = new Polygon();
        
        double[][] xy=new double[4*this.getWidth()][2];
        double t = p1;
        //        double min=0d, max=0d;
        System.out.println("p1:"+p1);
        xScale=this.getWidth()/(xmax-xmin); System.out.println("xScale:"+xScale);
        yScale=this.getHeight()/(ymax-ymin); System.out.println("yScale:"+yScale);
        for (double i = 0; i < this.getWidth(); i += DI){
            // build array of x and y, then find min and max
            xy[(int)(4*i)][0] = xMin+i*(xMax-xMin)/width; //current value on x-axis, in numbers, not pixels
            double p = Math.cos(xy[(int)(4*i)][0]);
            double q = Math.sin(xy[(int)(4*i)][0]);
            xy[(int)(4*i)][1] = p*(4*t*t-1)/((p*p+(q+2*t)*(q+2*t))*(p*p+(q+2*t)*(q+2*t))); //current value of function, in numbers
        }
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double j = -yScale * xy[(int)(4*i)][1] + yOffset; //current value of function, in pixels
//            System.out.println("am here");
//            System.out.println("("+xy[(int)(4*i)][0]+","+xy[(int)(4*i)][1]+")");
            grapher.addPoint((int) i, (int) j);
        }
        return grapher;
    }    
    
    
    
    public Polygon[] computePolygonArray(double xMin, double xMax, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon(xMin, xMax, yOffset);
        return polyArray;
    }    
    
    public Polygon[] computePolygonArray(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon(xScale, xOffset, yScale, yOffset);
        return polyArray;
    }
}