/*
 * IntersectTanhGraph.java
 *
 * Created on March 12, 2003, 6:28 PM
 */

package graphs;

/**
 *
 * @author  Ravi
 */

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;


public class IntersectTanhGraph extends TripleSliderGraph{
    
    /** Creates a new instance of IntersectTanhGraph */
    public IntersectTanhGraph() {
                jSlider1.setMinimum(0);
        jSlider2.setMinimum(0);
        jSlider1.setMaximum(1000000);
        jSlider2.setMaximum(20000);
        jSlider3.setMinimum(0);
        jSlider3.setMaximum(10000);
        
        jSlider1.setMajorTickSpacing(200000);
        jSlider1.setMinorTickSpacing(100000);
        Hashtable labelTable1 = new Hashtable();
        for (int i=-1000; i<=1000;i+=200)
        labelTable1.put( new Integer( i*1000 ), new JLabel(Integer.toString(i)) );
        jSlider1.setLabelTable(labelTable1);

        jSlider2.setMajorTickSpacing(5000);
        jSlider2.setMinorTickSpacing(1000);
        jSlider2.setMinimum(0);
        jSlider2.setMaximum(20000);
        Hashtable labelTable2 = new Hashtable();
        for (int i=0; i<=20;i+=5)
        labelTable2.put( new Integer( i*1000 ), new JLabel(Integer.toString(i)) );
        jSlider2.setLabelTable(labelTable2);


    }

    
    public Polygon[] computePolygonArray(double xMin, double xMax, double yOffset) {
        Polygon[] polyArray = new Polygon[2];
        polyArray[0] = computePolygon1(xMin, xMax, yOffset);
        polyArray[1] = computePolygon2(xMin, xMax, yOffset);
        return polyArray;
    }
    
    
    public void restoreDefaults(){
        xmin=0.0001;
        xmax=30;
        ymin=-10;
        ymax=10;
        p1=0;p2=0;p3=0;
        super.restoreDefaults();
        if (!firsttime) {jSlider1.setValue(0);jSlider2.setValue(0);jSlider3.setValue(0);}
    }

    
    public Polygon computePolygon1(double xMin, double xMax, double yOffset) {
        Polygon grapher = new Polygon();
        
        double[][] xy=new double[4*this.getWidth()][2];
        //        double min=0d, max=0d;
        System.out.println("p1:"+p1);
        xScale=this.getWidth()/(xmax-xmin); System.out.println("xScale:"+xScale);
        yScale=this.getHeight()/(ymax-ymin); System.out.println("yScale:"+yScale);
        for (double i = 0; i < this.getWidth(); i += DI){
            // build array of x and y, then find min and max
            xy[(int)(4*i)][0] = xMin+i*(xMax-xMin)/width; //current value on x-axis, in numbers, not pixels
            xy[(int)(4*i)][1] = tanh(xy[(int)(4*i)][0]); //current value of function, in numbers
            
        }
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double j = -yScale * xy[(int)(4*i)][1] + yOffset; //current value of function, in pixels
//            System.out.println("am here");
//            System.out.println("("+xy[(int)(4*i)][0]+","+xy[(int)(4*i)][1]+")");
            grapher.addPoint((int) i, (int) j);
        }
        return grapher;
    }        
    
    
    public Polygon computePolygon2(double xMin, double xMax, double yOffset) {
        Polygon grapher = new Polygon();
        
        double[][] xy=new double[4*this.getWidth()][2];
        //        double min=0d, max=0d;
        //System.out.println("p1:"+p1);
        xScale=this.getWidth()/(xmax-xmin); System.out.println("xScale:"+xScale);
        yScale=this.getHeight()/(ymax-ymin); System.out.println("yScale:"+yScale);
        for (double i = 0; i < this.getWidth(); i += DI){
            // build array of x and y, then find min and max
            xy[(int)(4*i)][0] = xMin+i*(xMax-xMin)/width; //current value on x-axis, in numbers, not pixels
            xy[(int)(4*i)][1] = p3*p3*p1/(p2 *xy[(int)(4*i)][0]);
 //current value of function, in numbers
//            xy[(int)(4*i)][1] = Math.sqrt((2.0 * xy[(int)(4*i)][0] * p2 + p1 * xy[(int)(4*i)][0] * xy[(int)(4*i)][0]) / (p1)); //current value of function, in numbers
        }
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double j = -yScale * xy[(int)(4*i)][1] + yOffset; //current value of function, in pixels
//            System.out.println("am here");
//            System.out.println("("+xy[(int)(4*i)][0]+","+xy[(int)(4*i)][1]+")");
            grapher.addPoint((int) i, (int) j);
        }
        return grapher;
    }    

    
    
    
    
    
    
    
    
    
    
    
    
    public Polygon[] computePolygonArray(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon[] polyArray = new Polygon[2];
        polyArray[0] = computePolygon1(xScale, xOffset, yScale, yOffset);
        polyArray[1] = computePolygon2(xScale, xOffset, yScale, yOffset);
        return polyArray;
    }
    
      public Polygon computePolygon2(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon grapher = new Polygon();
        double x;
        double y;
        double j;
        
        
        for (double i = this.getWidth(); i > 0; i += -DI){
            x = (i-xOffset)/xScale;
            y = p3*p3*p2/(p1 *x);
            j = yScale * y + yOffset;
            //System.out.print("("+x+","+y+")");
            grapher.addPoint((int) i, (int) j);
        }
        
        return grapher;
    }
      
      
        
    public Polygon computePolygon1(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon grapher = new Polygon();
        double x;
        double y;
        double j;
        
      
        for (double i = 0; i < this.getWidth(); i += DI){
            x = (i-xOffset)/xScale;
            y = tanh(x);
            j = yScale * y + yOffset;
            //System.out.print("("+x+","+y+")");
            grapher.addPoint((int) i, (int) j);
        }
        
        
        
        return grapher;
    }    
      
    
     public static double sinh(double myAngle) {
          double sinh = (Math.exp(myAngle)-Math.exp(-myAngle))/2;
          return sinh;
     }
     public static double cosh(double myAngle) {
          double cosh = (Math.exp(myAngle)+Math.exp(-myAngle))/2;
          return cosh;
     }
     public static double tanh(double myAngle) {
          double tanh = sinh(myAngle)/cosh(myAngle);
          return tanh;
     }
      
}



     
 
 