/*
 * MunkMomentGraph.java
 *
 * Created on March 12, 2003, 7:01 PM
 */

package graphs;

/**
 *
 * @author  Ravi
 */
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;


public class MunkMomentGraph extends TripleSliderGraph{
    
    /** Creates a new instance of IntersectTanhGraph */
    public MunkMomentGraph() {
        UCRGraf=true;
        drawPi=true;
        jSlider3.setMinimum(0);
        jSlider3.setMaximum(10000);
        Hashtable labelTable = new Hashtable();
        for (int i=0; i<=10;i+=1)
        labelTable.put( new Integer( i*1000 ), new JLabel(Integer.toString(i)) );
        jSlider3.setLabelTable(labelTable);        
        p1=0;
       // jSlider3.setMajorTickSpacing(2);
        
        
        
    }
    
        public Polygon[] computePolygonArray(double xMin, double xMax, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon(xMin, xMax, yOffset);
        return polyArray;
    }
    
    
    public void restoreDefaults(){
        xmin=-Math.PI/2;
        xmax=Math.PI/2;
        ymin=-5;
        ymax=5;
        super.restoreDefaults();
        if (!firsttime) {jSlider1.setValue(0);jSlider2.setValue(0);jSlider3.setValue(0);}
    }
    
    public Polygon computePolygon(double xMin, double xMax, double yOffset) {
        Polygon grapher = new Polygon();
        
        double[][] xy=new double[4*this.getWidth()][2];
        xScale=this.getWidth()/(xmax-xmin); System.out.println("xScale:"+xScale);
        yScale=this.getHeight()/(ymax-ymin); System.out.println("yScale:"+yScale);
        for (double i = 0; i < this.getWidth(); i += DI){
            // build array of x and y, then find min and max
            xy[(int)(4*i)][0] = xMin+i*(xMax-xMin)/width; //current value on x-axis, in numbers, not pixels
            xy[(int)(4*i)][1] = p3*p3*Math.sin(xy[(int)(4*i)][0]-Math.PI/2)*Math.cos(xy[(int)(4*i)][0]-Math.PI/2)*(p2-p1);; //current value of function, in numbers
        }
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double j = -yScale * xy[(int)(4*i)][1] + yOffset; //current value of function, in pixels
            grapher.addPoint((int) i, (int) j);
        }
        return grapher;
    }    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    public Polygon[] computePolygonArray(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon1(xScale, xOffset, yScale, yOffset);
        return polyArray;
    }
    
  
    
    public Polygon computePolygon1(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon grapher = new Polygon();
        double x;
        double y;
        double j;
        
        
        for (double i = 0; i < this.getWidth(); i += DI){
            x = (i-xOffset)/xScale;
            y = p3*p3*Math.sin(x)*Math.cos(x)*(p2-p1);
            j = yScale * y + yOffset;
            //System.out.print("("+x+","+y+")");
            grapher.addPoint((int) i, (int) j);
        }
        
        
        
        return grapher;
    }
    
    
    
}
