/*
 * ROvoidGraph.java
 *
 * Created on March 11, 2003, 1:16 AM
 */

package graphs;

/**
 *
 * @author  Ravi
 */
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

public class ROvoidGraph extends DoubleSliderGraph{
    
    /** Creates a new instance of TDSourceVGraph */
    public ROvoidGraph() {
        jSlider1.setMinimum(0);
        jSlider2.setMinimum(0);
        jSlider1.setMaximum(10000);
        jSlider2.setMaximum(10000);
        p1=0;
        p2=0;
        jSlider1.setValue(0);
        jSlider2.setValue(0);
    }
    
    
    public Polygon[] computePolygonArray(double xMin, double xMax, double yOffset) {
        Polygon[] polyArray = new Polygon[2];
        polyArray[0] = computePolygon1(xMin, xMax, yOffset);
        polyArray[1] = computePolygon2(xMin, xMax, yOffset);
        return polyArray;
    }
    
    
    public void restoreDefaults(){
        xmin=0.0001;
        xmax=10;
        ymin=-5;
        ymax=5;
        p1=0;p2=0;
        super.restoreDefaults();
        if (!firsttime) {jSlider1.setValue(0);jSlider2.setValue(0);}
    }
    
    public Polygon computePolygon1(double xMin, double xMax, double yOffset) {
        Polygon grapher = new Polygon();
        
        double[][] xy=new double[4*this.getWidth()][2];
        //        double min=0d, max=0d;
        //System.out.println("p1:"+p1);
        xScale=this.getWidth()/(xmax-xmin); System.out.println("xScale:"+xScale);
        yScale=this.getHeight()/(ymax-ymin); System.out.println("yScale:"+yScale);
        for (double i = 0; i < this.getWidth(); i += DI){
            // build array of x and y, then find min and max
            xy[(int)(4*i)][0] = xMin+i*(xMax-xMin)/width; //current value on x-axis, in numbers, not pixels
            xy[(int)(4*i)][1] = Math.pow((2.0 * xy[(int)(4*i)][0] * p2 + p1 * xy[(int)(4*i)][0] * xy[(int)(4*i)][0]) / (p1) , .5); //current value of function, in numbers
//            xy[(int)(4*i)][1] = Math.sqrt((2.0 * xy[(int)(4*i)][0] * p2 + p1 * xy[(int)(4*i)][0] * xy[(int)(4*i)][0]) / (p1)); //current value of function, in numbers
        }
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double j = -yScale * xy[(int)(4*i)][1] + yOffset; //current value of function, in pixels
//            System.out.println("am here");
//            System.out.println("("+xy[(int)(4*i)][0]+","+xy[(int)(4*i)][1]+")");
            grapher.addPoint((int) i, (int) j);
        }
        return grapher;
    }    

    public Polygon computePolygon2(double xMin, double xMax, double yOffset) {
        Polygon grapher = new Polygon();
        
        double[][] xy=new double[4*this.getWidth()][2];
        //        double min=0d, max=0d;
        System.out.println("p1:"+p1);
        xScale=this.getWidth()/(xmax-xmin); System.out.println("xScale:"+xScale);
        yScale=this.getHeight()/(ymax-ymin); System.out.println("yScale:"+yScale);
        for (double i = 0; i < this.getWidth(); i += DI){
            // build array of x and y, then find min and max
            xy[(int)(4*i)][0] = xMin+i*(xMax-xMin)/width; //current value on x-axis, in numbers, not pixels
            xy[(int)(4*i)][1] = -Math.pow((2.0 * xy[(int)(4*i)][0] * p2 + p1 * xy[(int)(4*i)][0] * xy[(int)(4*i)][0]) / (p1) , .5); //current value of function, in numbers
            
        }
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double j = -yScale * xy[(int)(4*i)][1] + yOffset; //current value of function, in pixels
//            System.out.println("am here");
//            System.out.println("("+xy[(int)(4*i)][0]+","+xy[(int)(4*i)][1]+")");
            grapher.addPoint((int) i, (int) j);
        }
        return grapher;
    }    
    

    
    public Polygon[] computePolygonArray(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon[] polyArray = new Polygon[2];
        polyArray[0] = computePolygon1(xScale, xOffset, yScale, yOffset);
        polyArray[1] = computePolygon2(xScale, xOffset, yScale, yOffset);
        return polyArray;
    }
    public Polygon computePolygon2(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon grapher = new Polygon();
        double x;
        double y;
        double j;
        
        
        for (double i = this.getWidth(); i > 0; i += -DI){
            x = (i-xOffset)/xScale;
            y = -Math.pow((2.0 * x * p1 + p2 * x * x) / (p2) , .5);
            j = yScale * y + yOffset;
            //System.out.print("("+x+","+y+")");
            grapher.addPoint((int) i, (int) j);
        }
        
        return grapher;
    }
    public Polygon computePolygon1(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon grapher = new Polygon();
        double x;
        double y;
        double j;
        
      
        for (double i = 0; i < this.getWidth(); i += DI){
            x = (i-xOffset)/xScale;
            y = Math.pow((2.0 * x * p1 + p2 * x * x) / (p2) , .5);
            j = yScale * y + yOffset;
            //System.out.print("("+x+","+y+")");
            grapher.addPoint((int) i, (int) j);
        }
        
        
        
        return grapher;
    }    
}
