package graphs;

/*
 * SinGraph.java
 *
 * Created on March 10, 2003, 9:52 PM
 */

/**
 *
 * @author  Ravi
 */
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;

public class TDSourcePGraph extends SingleSliderGraph{
    
    /** Creates a new instance of SinGraph */
    public TDSourcePGraph() {
        jSlider.setMinimum(-10000);
        jSlider.setMaximum(10000);
        Hashtable labelTable = new Hashtable();
        for (int i=-10; i<=10;i+=2)
        labelTable.put( new Integer( i*1000 ), new JLabel(Integer.toString(i)) );
        jSlider.setLabelTable(labelTable);        
        p1=0;
    }
    
    public Polygon[] computePolygonArray(double xMin, double xMax, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon(xMin, xMax, yOffset);
        return polyArray;
    }
    
    
    public void restoreDefaults(){
        xmin=0.0001;
        xmax=50;
        ymin=-5;
        ymax=5;
        super.restoreDefaults();
        if (!firsttime) jSlider.setValue(0);
    }
    
    public Polygon computePolygon(double xMin, double xMax, double yOffset) {
        Polygon grapher = new Polygon();
        
        double[][] xy=new double[4*this.getWidth()][2];
        //        double min=0d, max=0d;
        System.out.println("p1:"+p1);
        xScale=this.getWidth()/(xmax-xmin); System.out.println("xScale:"+xScale);
        yScale=this.getHeight()/(ymax-ymin); System.out.println("yScale:"+yScale);
        for (double i = 0; i < this.getWidth(); i += DI){
            // build array of x and y, then find min and max
            xy[(int)(4*i)][0] = xMin+i*(xMax-xMin)/width; //current value on x-axis, in numbers, not pixels
            xy[(int)(4*i)][1] = p1 / (2.0 * Math.PI) * Math.log(xy[(int)(4*i)][0])/ Math.log(Math.E); //current value of function, in numbers
        }
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double j = -yScale * xy[(int)(4*i)][1] + yOffset; //current value of function, in pixels
//            System.out.println("am here");
            System.out.println("("+xy[(int)(4*i)][0]+","+xy[(int)(4*i)][1]+")");
            grapher.addPoint((int) i, (int) j);
        }
        return grapher;
    }    
    
    
    
    
    
    
    
    
    
    
    
    
    public Polygon computePolygon(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon grapher = new Polygon();
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double x = (i-xOffset)/xScale;
            if(x != 0){
                double y = p1 / (2.0 * Math.PI) * Math.log(x)/ Math.log(Math.E);
                double j = yScale * y + yOffset;
                //System.out.print("("+i+","+j+")");
                grapher.addPoint((int) i, (int) j);
            }
        }
        
        return grapher;
    }
    public Polygon[] computePolygonArray(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon(xScale, xOffset, yScale, yOffset);
        return polyArray;
    }
    
    
    
}
