/*
 * WaveResistanceGraph.java
 *
 * Created on March 11, 2003, 9:09 PM
 */

package graphs;

import java.awt.*;
import javax.swing.*;

/**
 *
 * @author  Ravi
 */
public class WaveResistanceGraph extends GraphPanel{
    
    /** Creates a new instance of WaveResistanceGraph */
    public WaveResistanceGraph() {
    }
    
    public Polygon computePolygon(double xMin, double xMax, double yOffset) {
        Polygon grapher = new Polygon();
        
        double[][] xy=new double[4*this.getWidth()][2];
        //        double min=0d, max=0d;
//        System.out.println("p1:"+p1);
        xScale=this.getWidth()/(xmax-xmin); System.out.println("xScale:"+xScale);
        yScale=this.getHeight()/(ymax-ymin); System.out.println("yScale:"+yScale);
        for (double i = 0; i < this.getWidth(); i += DI){
            // build array of x and y, then find min and max
            xy[(int)(4*i)][0] = xMin+i*(xMax-xMin)/width; //current value on x-axis, in numbers, not pixels
            xy[(int)(4*i)][1] = Math.sin(1.0 / (2.0 * xy[(int)(4*i)][0] * xy[(int)(4*i)][0])) * Math.sin(1.0 / (2.0 * xy[(int)(4*i)][0] * xy[(int)(4*i)][0]));
        }
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double j = -yScale * xy[(int)(4*i)][1] + yOffset; //current value of function, in pixels
//            System.out.println("am here");
//            System.out.println("("+xy[(int)(4*i)][0]+","+xy[(int)(4*i)][1]+")");
            grapher.addPoint((int) i, (int) j);
        }
        return grapher;
    }    
    
    public Polygon[] computePolygonArray(double xMin, double xMax, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon(xMin, xMax, yOffset);
        return polyArray;
    }    
    

    public void restoreDefaults(){
        xmin=0.0001;
        xmax=3;
        ymin=-5;
        ymax=5;
        super.restoreDefaults();
    }        
    
    
    
    
    
    
    
    
    
    public Polygon computePolygon(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon grapher = new Polygon();
        
        xScale = this.getWidth() / 2.;
        xOffset = 0;
        yScale = -this.getHeight()/(2.0*1.0);
        yOffset = this.getHeight()/2.0;
        
        
        for (double i = 0; i < this.getWidth(); i += 1){
            double x = (i-xOffset)/xScale;
            double y = Math.sin(1.0 / (2.0 * x * x)) * Math.sin(1.0 / (2.0 * x * x));
            double j = yScale * y + yOffset;
            //System.out.print("("+x+","+y+")");
            grapher.addPoint((int) i, (int) j);
        }
        
        return grapher;
    }
    
    public JPanel getOptionsPanel() {
        JPanel jPanel = new JPanel();
        return jPanel;
    } 
    public Polygon[] computePolygonArray(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon(xScale, xOffset, yScale, yOffset);
        return polyArray;
    }    
}
